EDIT - bug #7910

TeamOrPersonField: readonly exception on bindig data
11/15/2018 08:25 AM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Release 5.5

Severity: normal Found in Version:

Description

Caused by: com.vaadin.data.Buffered$SourceException

at com.vaadin.ui.AbstractField.setPropertyDataSource (AbstractField. java:664)

at com.vaadin.data.fieldgroup.FieldGroup.bind (FieldGroup.java:273)

at com.vaadin.data.fieldgroup.BeanFieldGroup.bind(BeanFieldGroup.java:155)

at com.vaadin.data.fieldgroup.FieldGroup.bindFields (FieldGroup. java:113)

at com.vaadin.data.fieldgroup.FieldGroup.setItemDataSource (FieldGroup.java:103)

at com.vaadin.data.fieldgroup.BeanFieldGroup.setItemDataSource (BeanFieldGroup.java:126)

at eu.etaxonomy.cdm.vaadin.component.common.TeamOrPersonField.setInternalValue (TeamOrPersonFie
1d. java:205)

at eu.etaxonomy.cdm.vaadin.component.common.TeamOrPersonField.setInternalValue (TeamOrPersonFie
1d. java:1)

at com.vaadin.ui.AbstractField.setValue (AbstractField.java:526)

at eu.etaxonomy.cdm.vaadin.component.common.TeamOrPersonField.setValue (TeamOrPersonField. java:
387)

at eu.etaxonomy.cdm.vaadin.view.name.TaxonNamePopupEditor.updateAuthorshipFieldData (TaxonNameP
opupEditor. java:658)

at eu.etaxonomy.cdm.vaadin.view.name.TaxonNamePopupEditor.updateAuthorshipFields (TaxonNamePopu
pEditor. java:588)

at eu.etaxonomy.cdm.vaadin.view.name.TaxonNamePopupEditor.lambda$1l3 (TaxonNamePopupEditor. java:
681)

at sun.reflect.GeneratedMethodAccessorl99.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at com.vaadin.event.ListenerMethod.receiveEvent (ListenerMethod. java:510)

... 98 more
Caused by: com.vaadin.data.Property$SReadOnlyException

at com.vaadin.ui.AbstractField.setValue (AbstractField.java:493)

at com.vaadin.ui.AbstractField.setValue (AbstractField.java:468)

at com.vaadin.ui.AbstractField.setValue (AbstractField. java:453)

at eu.etaxonomy.cdm.vaadin.component.common.PersonField.setValue (PersonField. java:280)

at eu.etaxonomy.cdm.vaadin.component.common.PersonField.setValue (PersonField. java:l)

at eu.etaxonomy.vaadin.component.ToManyRelatedEntitiesListSelect.createFieldsForData (ToManyRel
atedEntitiesListSelect. java:270)

at eu.etaxonomy.vaadin.component.ToManyRelatedEntitiesListSelect.setInternalValue (ToManyRelate
dEntitiesListSelect. java:246)

at eu.etaxonomy.vaadin.component.ToManyRelatedEntitiesListSelect.setInternalValue (ToManyRelate
dEntitiesListSelect.java:1)

at com.vaadin.uil.AbstractField.setPropertyDataSource (AbstractField. java:657)

114 more

Related issues:
Related to EDIT - feature request #7600: public setters for entity collections Closed
Related to EDIT - bug #8217: ToManyRelatedEntitiesComboboxSelect edit button ... Closed

Associated revisions

Revision 64bf3ea5 - 11/16/2018 01:09 PM - Andreas Kohlbecker

ref #7910 ToManyRelatedEntitiesListSelect: no longer setting readlony on nested fields

Revision ea92bdaa - 11/16/2018 01:13 PM - Andreas Kohlbecker
ref #7910 TeamOrPersonField adapting read only state handling to available teammebers setter

History

#1 - 11/15/2018 08:45 AM - Andreas Kohlbecker

- Status changed from New to In Progress

The root of this problem is the Team class in which the setter for members is protected. This causes the PropertyDataSourcebeing readonly due to
the missing setter for this bean property.

The TermOrPersonField already has a hacky workaround to allow modifying the team members anyway:
fieldGroup.setItemDataSource (new BeanItem<Team> ( (Team)newValue)); // <<NEW PROBLEM
boolean readonlyState = personsListEditor.isReadOnly();

fieldGroup.bind (personsListEditor, "teamMembers");

// here personField is set readonly since setTeamMembers does not exist
personsListEditor.setReadOnly (readonlyState); // fixing the readonly state

But now a ReadonlyException already occurs at the line marked with // <<NEW PROBLEM if the internal value has been set before
#2 - 11/15/2018 09:38 AM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Mliller

- Priority changed from New to Highest

- % Done changed from 0 to 10

The preferred solution to this is making the setTeamMembers() in Team public
Are you ok with this Andreas Muller?

#3 - 11/16/2018 01:04 PM - Andreas Kohlbecker

- Related to feature request #7600: public setters for entity collections added

#4 - 11/16/2018 01:06 PM - Andreas Kohlbecker

- Assignee changed from Andreas Muiller to Andreas Kohlbecker

- % Done changed from 10 to 30

| implemented the EntityCollectionSetterAdapter (#7600) in order to provide a public setter method for teammembers.
The readonly state handling in the TeamOrPersonField needs to be changed afterwards.
#5-11/16/2018 01:15 PM - Andreas Kohlbecker

- Status changed from In Progress to Resolved

- Assignee changed from Andreas Kohlbecker to Wolf-Henning Kusber

- % Done changed from 30 to 50

Hallo Henning,

Das TeamOrPersonField sollte nun korrekt funktionieren. Bitte teste verschiedene Varianten durch.

#6 - 11/22/2018 09:26 AM - Andreas Miiller

- Subject changed from TermOrPersonField: readonly exception on bindig data to TeamOrPersonField: readonly exception on bindig data

#7 - 01/29/2019 07:32 PM - Wolf-Henning Kusber
- Assignee changed from Wolf-Henning Kusber to Andreas Kohlbecker

- % Done changed from 50 to 100

Habe keine Funktionsfehler mehr festgestellt. Kann geschlossen werden.

#8 - 01/30/2019 08:04 AM - Andreas Kohlbecker

- Status changed from Resolved to Closed
https://dev.e-taxonomy.eu/redmine/issues/7600

#9 - 04/02/2019 02:28 PM - Andreas Kohlbecker
- Related to bug #8217: ToManyRelatedEntitiesComboboxSelect edit button not enabled added
